=== llvm/lib/CMakeLists.txt ===
# `Support' and `TableGen' libraries are added on the top-level CMakeLists.txt

add_subdirectory(MC)
add_subdirectory(Target)
